# NON-EQUISPACED FOURIER NEURAL SOLVERS FOR PDES


This is a PyTorch implementation of NFS in the paper. 


## Requirements
* torch>=1.8.0 
* pytorch-scatter

Dependency can be installed using the following command:
```bash
conda env create --file env_nfs.yaml
conda activate NFSenv
```

## Dataset
Download the dataset from [ANONYMOUS GOOGLE DRIVE](https://drive.google.com/drive/folders/15EP8KgqJGLU98SCT-XUTqI6wKTt_J1ib?usp=sharing)

Copy it into `.\dataset\`.

## Training the Model

Run the following commands to train the model.
```
python NFS_BGS.py  #For BGS Equation

python NFS_KDV.py  #For KDV Equation

python NFS_NS.py  #For NS Equation

```



